<?php
/**
* @version Geommunity geocoder.php v1.3
* @author Adrien ROUSSEL
* http://geommunity.nordmograph.com
* @package joomla! community builder
* @subpackage Geommunity Geocoder
* @license http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
*/
// ensure this file is being included by a parent file
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) {
	die( 'Direct Access to this location is not allowed.' );
}

// register geocoder function
$_PLUGINS->registerFunction('onBeforeNewUser', 'geocodeAddress', 'geommunitygeocoder');
$_PLUGINS->registerFunction('onBeforeUserUpdate', 'geocodeAddress', 'geommunitygeocoder');
//$_PLUGINS->registerFunction('onBeforeUserRegistration', 'geocodeAddress', 'geommunitygeocoder');
$_PLUGINS->registerFunction('onAfterUserRegistration', 'geocodeAddress', 'geommunitygeocoder');
class geocoder {
	var $address = null;
	var $city = null;
	var $state = null;
	var $country = null;
	var $zipcode = null;
	var $lat = null;
	var $lng = null;
	function geocoder($geoData, $address='address', $city='city', $state='state', $country='country', $zipcode='zipcode', $lat='lat', $lng='lng') {
		$this->address = $geoData->$address;
		$this->city = $geoData->$city;
		$this->state = $geoData->$state;
		$this->country = $geoData->$country;
		$this->zipcode = $geoData->$zipcode;
		return true;
	}
	function geocodeAddress($params) {
		$query = trim($this->address).','.trim($this->city).','.trim($this->state).','.trim($this->zipcode).','.trim($this->country);
		$query = preg_replace('/^,|,$/', '', preg_replace('/(,)*/', '$1', $query));
		//if (_ISO == 'charset=utf-8')
		//$query = utf8_decode($query);
		$query = urlencode($query);
		$result = $this->googleGeocode($query,$params);
		$lat = $result['lat'];
		$lng = $result['lng'];
		if ($lat == false || $lng == false || $lat=="0" || $lng=="0") {
			$result = $this->yahooGeocode($query, $params);
			$lat = $result['lat'];
			$lng = $result['lng'];
		}
		$this->latitude = $lat ? $lat : $this->latitude;
		$this->longitude = $lng ? $lng : $this->longitude;
		return true;
	}
	function googleGeocode($query,$params) {
		$debug = $params->get('debug',0);
		$qurl = 'http://maps.googleapis.com/maps/api/geocode/xml?address='. $query.'&sensor=false';
		
		$c = curl_init();
		curl_setopt($c, CURLOPT_URL, $qurl);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, 1);
		$xmlContent = trim(curl_exec($c));
		curl_close($c);
		if($debug && strpos($xmlContent,'OVER_QUERY_LIMIT')){
			$app = JFactory::getApplication();
			$app->enqueueMessage('Google: '.$xmlContent.': <a href="'.$qurl.'" target="_blank">Google URL</a>');			
		}
		$xmlObject = simplexml_load_string($xmlContent);
		$result['lat'] = (string) $xmlObject->result->geometry->location->lat;
		$result['lng'] = (string) $xmlObject->result->geometry->location->lng;
		return $result;
	}
	function yahooGeocode($query,$params) {
	
		$debug = $params->get('debug',0);
		$geourl  = "http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20geo.placefinder%20where%20text%20%3D%20%221%20".$query."%22&format=json&diagnostics=true";
		if($debug){
			$app = JFactory::getApplication();
			$app->enqueueMessage('<a href="'.$geourl.'" target="_blank">Yahoo URL</a> ');
		}	
		$xmlContent = file_get_contents($geourl);
		$obj = json_decode($xmlContent);
		$result['lat'] = (string) $obj->query->results->Result->latitude;
		$result['lng'] = (string) $obj->query->results->Result->longitude;	
		return $result;
	}
}

class geommunitygeocoder extends cbTabHandler {
	function geocodeAddress($user,$cbUser) {
		global $_CB_database;
		$db = $_CB_database;
		$params = $this->params;
		$mode = $params->get('mode',0);
		
		$place = new geocoder($cbUser, $params->get('geoAddress','cb_address'), $params->get('geoCity','cb_city'), $params->get('geoState','cb_state'), $params->get('geoCountry','cb_country'), $params->get('geoZipcode','cb_zipcode'), $lat='cb_geolat', $lng='cb_geolng');
		$place->geocodeAddress($params);
		if ( $mode==1 && ($cbUser->$lat == '' || $cbUser->$lng == '') ) { // on profile update and a missing coordinate
			$cbUser->$lat = $place->latitude ? $place->latitude : $cbUser->$lat;
			$cbUser->$lng = $place->longitude ? $place->longitude : $cbUser->$lng;			
			$query ="UPDATE #__comprofiler SET cb_geolat='".$cbUser->$lat."',cb_geolng='".$cbUser->$lng."' WHERE id='".$user->id."'";
			$db->setQuery($query);
           $db->query();
		}
		elseif( $mode==0 ){ // every profile update
			$cbUser->$lat = $place->latitude ? $place->latitude : $cbUser->$lat;
			$cbUser->$lng = $place->longitude ? $place->longitude : $cbUser->$lng;
			$query ="UPDATE #__comprofiler SET cb_geolat='".$cbUser->$lat."',cb_geolng='".$cbUser->$lng."' WHERE id='".$user->id."'";
			$db->setQuery($query);
            $db->query();
				
		}	
		
	}
	
	
	
	
	
	
	
	
	
	function getDisplayTab($tab,$user,$ui) {
		global $_CB_framework,$_CB_database,$ueConfig;
		$doc			= JFactory::getDocument();
		$jinput		= JFactory::getApplication()->input;
		$juri = $_CB_framework->getCfg( 'live_site' );
		$db = $_CB_database;
		$lang =$_CB_framework->getCfg( 'lang' );
		$absolute_path = $_CB_framework->getCfg( 'absolute_path' );
		$my_id = $_CB_framework->myId();
		$userid = $user->id;
		$html ='';

		$languagePath=$absolute_path.'/components/com_comprofiler/plugin/user/plug_geommunitygeocoder';
		if (file_exists($languagePath.'/lang/'.$lang.'.php'))
		  include_once($languagePath.'/lang/'.$lang.'.php');
		else include_once($languagePath.'/lang/english.php');
		
		include_once JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
		if($ueConfig['name_format']=='1' || $ueConfig['name_format']=='2')
			$fnaming 	= 'name';
		else
			$fnaming 	= 'username';
	
	
		$params = $this->params;
		
		$mymarker = '';

		
		$type = $params->get('type','ROADMAP');
		$width = $params->get('width','100%');
		$height = $params->get('height','400px');
		$zoom = $params->get('zoom','5');
		$minzoom = $params->get('minzoom','1');
		$maxzoom = $params->get('maxzoom','20');
		$scrollwheel = $params->get('scrollwheel',1);
		if($scrollwheel) $scrollwheel='true';
		else $scrollwheel='false';
		$showfriends = $params->get('showfriends',1);
		$showstreetview = $params->get('showstreetview',1);

		$stylez = $params->get('stylez');



		$user_username = ucfirst($user->$fnaming);
		
	

    	if ( 	$user->cb_geolng!="" && $user->cb_geolat!=""  && is_numeric($user->cb_geolat)  && is_numeric($user->cb_geolng)
				
			)
		{
      		$lat = $user->cb_geolat;
			$lng = $user->cb_geolng;

    	//}
		

			$mapscript ="function add_Event(obj_, evType_, fn_){ 
						if (obj_.addEventListener)
							obj_.addEventListener(evType_, fn_, false); 
						else
							obj_.attachEvent('on'+evType_, fn_);  
					}		
	
	  function initializemap(){
				directionsDisplay = new google.maps.DirectionsRenderer();
				var latlng = new google.maps.LatLng(".$lat.",".$lng.");
				var myOptions = {
					zoom: ".$zoom.",
					minZoom: ".$minzoom.",
					maxZoom: ".$maxzoom.",
					center: latlng,
					mapTypeId: google.maps.MapTypeId.".$type.",
					scrollwheel: ".$scrollwheel.",
					navigationControl: true,
					scaleControl: true,
					mapTypeControl: true,
					streetViewControl: ".$showstreetview."
				}
				var map = new google.maps.Map(document.getElementById('map'), myOptions);
				directionsDisplay.setMap(map);
				directionsDisplay.setPanel(document.getElementById(\"directionspanel\"));
				var me = new google.maps.LatLng($lat,$lng);
				var marker = new google.maps.Marker({						
					position: me,
					map: map,
					clickable: true,					
					title:'".$user_username."'
				});
				
			
				var infobulle = new google.maps.InfoWindow({
				content:'".$user_username." ";

			$mapscript .="<div style=\'text-align:center;width:250px;height:230px\' title=\'"._GL_QRTITLE."\' class=\'hasTooltip\'><img src=\'//chart.googleapis.com/chart?cht=qr&chs=200x200&chl=geo%3A".$lat."%2C".$lng."\' width=\'200\' height=\'200\' alt=\'Geo QRCode\'/></div>";
		
			$mapscript .="'});
				google.maps.event.addListener(marker,'click',function(){
					infobulle.open(map, marker);
				});
				infobulle.open(map, marker);";
		

			if($stylez!='')
			{
				$mapscript .="var stylez = ".$stylez.";
				var styledMapOptions = {
					name: '1'
				}
				var GeommunityLocatorMapType = new google.maps.StyledMapType( stylez, styledMapOptions);
				map.mapTypes.set('1', GeommunityLocatorMapType);
				map.setMapTypeId('1');";	
			}
			$mapscript .= $mymarker;
			$mapscript .= "}
			function initgmap() {
				arguments.callee.done = true;
				initializemap();
			};
    		add_Event(window, 'load', initgmap);";
		}

		if($lat !=0 && $lng!=0 && $lat!='' && $lng!='')
		{		
			$api_url= '//maps.googleapis.com/maps/api/js?key='.$js_apikey.'&sensor=false';
			if($js_client !='' && $js_signature !='' )
				$api_url .= '&client='.$js_client.'&signature='.$js_signature;		
			$doc->addScript( $api_url );
					
			$doc->addScriptDeclaration($mapscript);
			$html .= "<div id=\"map\" style=\"height:".$height.";width:".$width.";\">";
	
			$html .= "</div>";
			$html .= '<a class="btn btn-small" href="javascript:initgmap();"><span class="icon-loop"></span> '._GL_RESETMAP.'</a>';		
		}
		return $html;
	}
}
?>